/*
 * Copyright (C) 2017  Kevin Whitaker <eyecreate@gmail.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 *
 */

#ifndef TRACKDETAILS_H
#define TRACKDETAILS_H

#include <Wt/WContainerWidget>
#include <Wt/WHBoxLayout>
#include <Wt/WVBoxLayout>
#include <Wt/WText>
#include <Wt/WImage>
#include <Wt/WMemoryResource>
#include "../db/AudioTrack.h"

class TrackDetails : public Wt::WContainerWidget
{
public:
    TrackDetails();
    ~TrackDetails();
    Wt::WHBoxLayout* mainLayout;
    Wt::WVBoxLayout* metaLayout;
    
    Wt::WImage* albumCover;
    Wt::WMemoryResource* coverData;
    Wt::WText* trackTitle;
    Wt::WText* trackArtist;
    Wt::WText* trackAlbum;
    
    std::string trackFingerprint;
    std::string trackGenre;
    
    void updateWithTrackDetails(AudioTrack track);
    void changeBackgroundColor(Wt::WColor color);
    bool trackMatches(AudioTrack track);
    AudioTrack extractTrackFromDetails();
};

#endif // TRACKDETAILS_H
